/***************************************************
	mined keyboard mapping table
	* generated with mkkbmap
	  from lib/kbmaps/cxterm/jis/ROMKANA.tit, 
	  fixing buggy multiple choice entries into two-character mappings
	* with additional entries generated with mkkbmap Hiragana
	  from UnicodeData.txt (mainly for HIRAGANA SMALL LETTERS)
	* with additional punctuation mappings
	* with fixes and completions by Mike Fabian
*/
struct keymap keymap_Hiragana [] = {
	{"~", "〜 ￣"},
	{"!", "！"},
	{"#", "＃"},
	{"$", "＄ ￥ ￦ ￡ ￠"},
	{"&", "＆"},
	{"(", "（"},
	{")", "）"},
	{",", "、"},
	{".", "。 ・ … ‥"},
	{":", "："},
	{";", "；"},
	{"<", "〈"},
	{"<<", "《"},
	{">", "〉"},
	{">>", "》"},
	{"?", "？"},
	{"@", "＠ ・"},
	{"\\", "￥"},
	{"[", "「"},
	{"{", "「 〈 《 【 『"},
	{"]", "」"},
	{"}", "」 〉 》 】 』"},
	{"%", "％"},
	{"^", "＾"},
	{"_", "＿"},
	{"«", "《"},
	{"»", "》"},
	{"-", "ー"},
	{"/", "／"},
	{"`", "｀"},
	{"*", "＊"},
	{"+", "＋"},
	{"|", "｜"},
	{"1", "１"},
	{"2", "２"},
	{"3", "３"},
	{"4", "４"},
	{"5", "５"},
	{"6", "６"},
	{"7", "７"},
	{"8", "８"},
	{"9", "９"},
	{"0", "０"},

	{"k", "っ"},
	{"s", "っ"},
	{"t", "っ"},
	{"h", "っ"},
	{"m", "っ"},
	{"y", "っ"},
	{"r", "っ"},
	{"w", "っ"},
	{"g", "っ"},
	{"z", "っ"},
	{"d", "っ"},
	{"b", "っ"},
	{"p", "っ"},
	{"c", "っ"},
	{"f", "っ"},
	{"j", "っ"},
	{"q", "っ"},
	{"v", "っ"},
	{"t", "っ"},

	{"xa", "ぁ"},
	{"xi", "ぃ"},
	{"xu", "ぅ"},
	{"xe", "ぇ"},
	{"xo", "ぉ"},
	{"xtu", "っ"},
	{"xtsu", "っ"},
	{"xya", "ゃ"},
	{"xyu", "ゅ"},
	{"xyo", "ょ"},
	{"xwa", "ゎ"},
	{"xka", "ゕ"},
	{"xke", "ゖ"},

	{"a", "あ"},
	{"i", "い"},
	{"u", "う"},
	{"e", "え"},
	{"o", "お"},
	{"ka", "か"},
	{"ki", "き"},
	{"ku", "く"},
	{"ke", "け"},
	{"ko", "こ"},
	{"kya", "きゃ"},
	{"kyi", "きぃ"},
	{"kyu", "きゅ"},
	{"kye", "きぇ"},
	{"kyo", "きょ"},
	{"sa", "さ"},
	{"si", "し"},
	{"su", "す"},
	{"se", "せ"},
	{"so", "そ"},
	{"sya", "しゃ"},
	{"syi", "しぃ"},
	{"syu", "しゅ"},
	{"sye", "しぇ"},
	{"syo", "しょ"},
	{"sha", "しゃ"},
	{"shi", "し"},
	{"shu", "しゅ"},
	{"she", "しぇ"},
	{"sho", "しょ"},
	{"ta", "た"},
	{"ti", "ち"},
	{"tu", "つ"},
	{"te", "て"},
	{"to", "と"},
	{"tsa", "つぁ"},
	{"tsi", "つぃ"},
	{"tsu", "つ"},
	{"tse", "つぇ"},
	{"tso", "つぉ"},
	{"tha", "てゃ"},
	{"thi", "てぃ"},
	{"thu", "てゅ"},
	{"the", "てぇ"},
	{"tho", "てょ"},
	{"tya", "ちゃ"},
	{"tyi", "ちぃ"},
	{"tyu", "ちゅ"},
	{"tye", "ちぇ"},
	{"tyo", "ちょ"},
	{"cha", "ちゃ"},
	{"chi", "ち"},
	{"chu", "ちゅ"},
	{"che", "ちぇ"},
	{"cho", "ちょ"},
	{"na", "な"},
	{"ni", "に"},
	{"nu", "ぬ"},
	{"ne", "ね"},
	{"no", "の"},
	{"nya", "にゃ"},
	{"nyi", "にぃ"},
	{"nyu", "にゅ"},
	{"nye", "にぇ"},
	{"nyo", "にょ"},
	{"ha", "は"},
	{"hi", "ひ"},
	{"hu", "ふ"},
	{"he", "へ"},
	{"ho", "ほ"},
	{"hya", "ひゃ"},
	{"hyi", "ひぃ"},
	{"hyu", "ひゅ"},
	{"hye", "ひぇ"},
	{"hyo", "ひょ"},
	{"fa", "ふぁ"},
	{"fi", "ふぃ"},
	{"fu", "ふ"},
	{"fe", "ふぇ"},
	{"fo", "ふぉ"},
	{"ma", "ま"},
	{"mi", "み"},
	{"mu", "む"},
	{"me", "め"},
	{"mo", "も"},
	{"mya", "みゃ"},
	{"myi", "みぃ"},
	{"myu", "みゅ"},
	{"mye", "みぇ"},
	{"myo", "みょ"},
	{"ya", "や"},
	{"yi", "い"},
	{"yu", "ゆ"},
	{"ye", "いぇ"},
	{"yo", "よ"},
	{"ra", "ら"},
	{"ri", "り"},
	{"ru", "る"},
	{"re", "れ"},
	{"ro", "ろ"},
	{"la", "ら"},
	{"li", "り"},
	{"lu", "る"},
	{"le", "れ"},
	{"lo", "ろ"},
	{"rya", "りゃ"},
	{"ryi", "りぃ"},
	{"ryu", "りゅ"},
	{"rye", "りぇ"},
	{"ryo", "りょ"},
	{"lya", "りゃ"},
	{"lyi", "りぃ"},
	{"lyu", "りゅ"},
	{"lye", "りぇ"},
	{"lyo", "りょ"},
	{"wa", "わ"},
	{"wi", "ゐ"},
	{"wu", "う"},
	{"we", "ゑ"},
	{"wo", "を"},
	{"ga", "が"},
	{"gi", "ぎ"},
	{"gu", "ぐ"},
	{"ge", "げ"},
	{"go", "ご"},
	{"gya", "ぎゃ"},
	{"gyi", "ぎぃ"},
	{"gyu", "ぎゅ"},
	{"gye", "ぎぇ"},
	{"gyo", "ぎょ"},
	{"za", "ざ"},
	{"zi", "じ"},
	{"zu", "ず"},
	{"ze", "ぜ"},
	{"zo", "ぞ"},
	{"zya", "じゃ"},
	{"zyi", "じぃ"},
	{"zyu", "じゅ"},
	{"zye", "じぇ"},
	{"zyo", "じょ"},
	{"ja", "じゃ"},
	{"ji", "じ"},
	{"ju", "じゅ"},
	{"je", "じぇ"},
	{"jo", "じょ"},
	{"da", "だ"},
	{"di", "ぢ"},
	{"du", "づ"},
	{"de", "で"},
	{"do", "ど"},
	{"dha", "でゃ"},
	{"dhi", "でぃ"},
	{"dhu", "でゅ"},
	{"dhe", "でぇ"},
	{"dho", "でょ"},
	{"dya", "ぢゃ"},
	{"dyi", "ぢぃ"},
	{"dyu", "ぢゅ"},
	{"dye", "ぢぇ"},
	{"dyo", "ぢょ"},
	{"ba", "ば"},
	{"bi", "び"},
	{"bu", "ぶ"},
	{"be", "べ"},
	{"bo", "ぼ"},
	{"bya", "びゃ"},
	{"byi", "びぃ"},
	{"byu", "びゅ"},
	{"bye", "びぇ"},
	{"byo", "びょ"},
	{"pa", "ぱ"},
	{"pi", "ぴ"},
	{"pu", "ぷ"},
	{"pe", "ぺ"},
	{"po", "ぽ"},
	{"pya", "ぴゃ"},
	{"pyi", "ぴぃ"},
	{"pyu", "ぴゅ"},
	{"pye", "ぴぇ"},
	{"pyo", "ぴょ"},
	{"gwa", "ぐゎ"},
	{"gwi", "ぐぃ"},
	{"gwu", "ぐぅ"},
	{"gwe", "ぐぇ"},
	{"gwo", "ぐぉ"},
	{"n", "ん"},
	{"mn", "ん"},
	{"vu", "ゔ"},

	{"_yori", "ゟ"},

	{NIL_PTR}
};
